package ${basePackage!}.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import ${basePackage!}.entity.${table.entityName};
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.aop.CyPageUtilAsp;
import org.rcisoft.core.model.CyPageInfo;

import java.util.List;

/**
 * Created by ${author!} on ${.now}.
 */
public interface ${table.entityName!}Service {

    /**
    * 保存 ${table.tableRemark!}
    * @param ${table.entityName?uncap_first}
    * @return
    */
    CyPersistModel persist(${table.entityName!} ${table.entityName?uncap_first});

    /**
    * 删除 ${table.tableRemark!}
    * @param ${table.entityName?uncap_first}
    * @return
    */
    CyPersistModel remove(${table.entityName!} ${table.entityName?uncap_first});
    <#if table.idEntity == true>
    /**
    * 逻辑删除 ${table.tableRemark!}
    * @param ${table.entityName?uncap_first}
    * @return
    */
    CyPersistModel removeLogical(${table.entityName!} ${table.entityName?uncap_first});
    </#if>
    /**
    * 修改 ${table.tableRemark!}
    * @param ${table.entityName?uncap_first}
    * @return
    */
    CyPersistModel merge(${table.entityName!} ${table.entityName?uncap_first});

    /**
    * 根据id查询 ${table.tableRemark!}
    * @param id
    * @return
    */
    <#if table.increment == false>
    ${table.entityName!} findById(String id);
    </#if>
    <#if table.increment == true>
    ${table.entityName!} findById(int id);
    </#if>

    /**
    * 分页查询 ${table.tableRemark!}
    * @param ${table.entityName?uncap_first}
    * @return
    */
<#--    List<${table.entityName!}> findAllByPagination(CyPageUtil<${table.entityName!}> paginationUtility,-->
    IPage<${table.entityName!}> findAllByPagination(CyPageInfo<${table.entityName!}> paginationUtility,
              ${table.entityName!} ${table.entityName?uncap_first});


    /**
    * 查询list ${table.tableRemark!}
    * @param ${table.entityName?uncap_first}
    * @return
    */
    List<${table.entityName!}> findAll(${table.entityName!} ${table.entityName?uncap_first});


    /**
    * 导出${table.tableRemark!}
    * @return
    */
    List<${table.entityName!}> export(${table.entityName!} ${table.entityName?uncap_first});

}
